/* This file was generated by SableCC (http://www.sablecc.org/). */

package net.sourceforge.texlipse.bibparser.lexer;

import java.io.BufferedInputStream;
import java.io.DataInputStream;
import java.io.IOException;
import java.io.PushbackReader;

import net.sourceforge.texlipse.bibparser.node.EOF;
import net.sourceforge.texlipse.bibparser.node.TBString;
import net.sourceforge.texlipse.bibparser.node.TComma;
import net.sourceforge.texlipse.bibparser.node.TComment;
import net.sourceforge.texlipse.bibparser.node.TEntryName;
import net.sourceforge.texlipse.bibparser.node.TEquals;
import net.sourceforge.texlipse.bibparser.node.TEstring;
import net.sourceforge.texlipse.bibparser.node.TIdentifier;
import net.sourceforge.texlipse.bibparser.node.TLBrace;
import net.sourceforge.texlipse.bibparser.node.TLParen;
import net.sourceforge.texlipse.bibparser.node.TNumber;
import net.sourceforge.texlipse.bibparser.node.TPreamble;
import net.sourceforge.texlipse.bibparser.node.TQuotec;
import net.sourceforge.texlipse.bibparser.node.TRBrace;
import net.sourceforge.texlipse.bibparser.node.TRParen;
import net.sourceforge.texlipse.bibparser.node.TScribeComment;
import net.sourceforge.texlipse.bibparser.node.TSharp;
import net.sourceforge.texlipse.bibparser.node.TStringLiteral;
import net.sourceforge.texlipse.bibparser.node.TWhitespace;
import net.sourceforge.texlipse.bibparser.node.Token;


public class Lexer
{
    protected Token token;
    protected State state = State.NORMAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();

    protected void filter() throws LexerException, IOException
    {
    }

    public Lexer(PushbackReader in)
    {
        this.in = in;

        if(gotoTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Lexer.class.getResourceAsStream("lexer.dat")));

                // read gotoTable
                int length = s.readInt();
                gotoTable = new int[length][][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][][];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        length = s.readInt();
                        gotoTable[i][j] = new int[length][3];
                        for(int k = 0; k < gotoTable[i][j].length; k++)
                        {
                            for(int l = 0; l < 3; l++)
                            {
                                gotoTable[i][j][k][l] = s.readInt();
                            }
                        }
                    }
                }

                // read accept
                length = s.readInt();
                accept = new int[length][];
                for(int i = 0; i < accept.length; i++)
                {
                    length = s.readInt();
                    accept[i] = new int[length];
                    for(int j = 0; j < accept[i].length; j++)
                    {
                        accept[i][j] = s.readInt();
                    }
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
            }
        }
    }

    public Token peek() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        return token;
    }

    public Token next() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        Token result = token;
        token = null;
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = pos;
        int start_line = line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

        int[][][] gotoTable = this.gotoTable[state.id()];
        int[] accept = this.accept[state.id()];
        text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(cr)
                    {
                        cr = false;
                    }
                    else
                    {
                        line++;
                        pos = 0;
                    }
                    break;
                case 13:
                    line++;
                    pos = 0;
                    cr = true;
                    break;
                default:
                    pos++;
                    cr = false;
                    break;
                };

                text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = text.length();
                    accept_pos = pos;
                    accept_line = line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                            Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.ASSIGN; break;
                                case 3: state = State.BRACESTRING; break;
                                case 1: state = State.INENTRY; break;
                                case 5: state = State.REMOVE; break;
                            }
                            return token;
                        }
                    case 1:
                        {
                            Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.INENTRY; break;
                            }
                            return token;
                        }
                    case 2:
                        {
                            Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.REMOVE; break;
                            }
                            return token;
                        }
                    case 3:
                        {
                            Token token = new3(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.REMOVE; break;
                            }
                            return token;
                        }
                    case 4:
                        {
                            Token token = new4(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.INENTRY; break;
                            }
                            return token;
                        }
                    case 5:
                        {
                            Token token = new5(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 6:
                        {
                            Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.BRACESTRING; break;
                                case 3: state = State.BRACESTRING; break;
                                case 1: state = State.INENTRY; break;
                                case 5: state = State.REMOVE; break;
                            }
                            return token;
                        }
                    case 7:
                        {
                            Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.NORMAL; break;
                                case 3: state = State.BRACESTRING; break;
                                case 1: state = State.NORMAL; break;
                                case 5: state = State.REMOVE; break;
                            }
                            return token;
                        }
                    case 8:
                        {
                            Token token = new8(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.BRACESTRING; break;
                                case 5: state = State.REMOVE; break;
                            }
                            return token;
                        }
                    case 9:
                        {
                            Token token = new9(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.INENTRY; break;
                            }
                            return token;
                        }
                    case 10:
                        {
                            Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.NORMAL; break;
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 11:
                        {
                            Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.INENTRY; break;
                                case 1: state = State.INENTRY; break;
                            }
                            return token;
                        }
                    case 12:
                        {
                            Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.ASSIGN; break;
                            }
                            return token;
                        }
                    case 13:
                        {
                            Token token = new13(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.ASSIGN; break;
                            }
                            return token;
                        }
                    case 14:
                        {
                            Token token = new14(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.ASSIGN; break;
                            }
                            return token;
                        }
                    case 15:
                        {
                            Token token = new15(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.ASSIGN; break;
                                case 1: state = State.INENTRY; break;
                            }
                            return token;
                        }
                    case 16:
                        {
                            Token token = new16(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.QSTRING; break;
                                case 4: state = State.ASSIGN; break;
                            }
                            return token;
                        }
                    case 17:
                        {
                            Token token = new17(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 4: state = State.QSTRING; break;
                            }
                            return token;
                        }
                    }
                }
                else
                {
                    if(text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + text);
                    }
                    else
                    {
                        EOF token = new EOF(
                            start_line + 1,
                            start_pos + 1);
                        return token;
                    }
                }
            }
        }
    }

    Token new0(String text, int line, int pos) { return new TWhitespace(text, line, pos); }
    Token new1(String text, int line, int pos) { return new TEstring(text, line, pos); }
    Token new2(String text, int line, int pos) { return new TScribeComment(text, line, pos); }
    Token new3(String text, int line, int pos) { return new TPreamble(text, line, pos); }
    Token new4(String text, int line, int pos) { return new TEntryName(text, line, pos); }
    Token new5(String text, int line, int pos) { return new TComment(text, line, pos); }
    Token new6(int line, int pos) { return new TLBrace(line, pos); }
    Token new7(int line, int pos) { return new TRBrace(line, pos); }
    Token new8(String text, int line, int pos) { return new TBString(text, line, pos); }
    Token new9(int line, int pos) { return new TLParen(line, pos); }
    Token new10(int line, int pos) { return new TRParen(line, pos); }
    Token new11(int line, int pos) { return new TComma(line, pos); }
    Token new12(int line, int pos) { return new TEquals(line, pos); }
    Token new13(int line, int pos) { return new TSharp(line, pos); }
    Token new14(String text, int line, int pos) { return new TNumber(text, line, pos); }
    Token new15(String text, int line, int pos) { return new TIdentifier(text, line, pos); }
    Token new16(int line, int pos) { return new TQuotec(line, pos); }
    Token new17(String text, int line, int pos) { return new TStringLiteral(text, line, pos); }

    private int getChar() throws IOException
    {
        if(eof)
        {
            return -1;
        }

        int result = in.read();

        if(result == -1)
        {
            eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }
    }

    protected void unread(Token token) throws IOException
    {
        String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }

        pos = token.getPos() - 1;
        line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // NORMAL
            {{0, 63, 1}, {64, 64, 2}, {65, 65535, 1}, },
            {{0, 63, 1}, {65, 65535, 1}, },
            {{65, 66, 3}, {67, 67, 4}, {68, 79, 3}, {80, 80, 5}, {81, 82, 3}, {83, 83, 6}, {84, 90, 3}, {97, 98, 7}, {99, 99, 8}, {100, 111, 7}, {112, 112, 9}, {113, 114, 7}, {115, 115, 10}, {116, 122, 7}, },
            {{65, 90, 3}, {97, 122, 7}, },
            {{65, 78, 3}, {79, 79, 11}, {80, 90, 3}, {97, 110, 7}, {111, 111, 12}, {112, 122, 7}, },
            {{65, 81, 3}, {82, 82, 13}, {83, 90, 3}, {97, 113, 7}, {114, 114, 14}, {115, 122, 7}, },
            {{65, 83, 3}, {84, 84, 15}, {85, 90, 3}, {97, 115, 7}, {116, 116, 16}, {117, 122, 7}, },
            {{65, 122, -5}, },
            {{65, 122, -6}, },
            {{65, 122, -7}, },
            {{65, 122, -8}, },
            {{65, 76, 3}, {77, 77, 17}, {78, 90, 3}, {97, 108, 7}, {109, 109, 18}, {110, 122, 7}, },
            {{65, 122, -13}, },
            {{65, 68, 3}, {69, 69, 19}, {70, 90, 3}, {97, 100, 7}, {101, 101, 20}, {102, 122, 7}, },
            {{65, 122, -15}, },
            {{65, 81, 3}, {82, 82, 21}, {83, 113, -7}, {114, 114, 22}, {115, 122, 7}, },
            {{65, 122, -17}, },
            {{65, 76, 3}, {77, 77, 23}, {78, 108, -13}, {109, 109, 24}, {110, 122, 7}, },
            {{65, 122, -19}, },
            {{65, 65, 25}, {66, 90, 3}, {97, 97, 26}, {98, 122, 7}, },
            {{65, 122, -21}, },
            {{65, 72, 3}, {73, 73, 27}, {74, 90, 3}, {97, 104, 7}, {105, 105, 28}, {106, 122, 7}, },
            {{65, 122, -23}, },
            {{65, 68, 3}, {69, 69, 29}, {70, 100, -15}, {101, 101, 30}, {102, 122, 7}, },
            {{65, 122, -25}, },
            {{65, 76, 3}, {77, 77, 31}, {78, 108, -13}, {109, 109, 32}, {110, 122, 7}, },
            {{65, 122, -27}, },
            {{65, 77, 3}, {78, 78, 33}, {79, 90, 3}, {97, 109, 7}, {110, 110, 34}, {111, 122, 7}, },
            {{65, 122, -29}, },
            {{65, 77, 3}, {78, 78, 35}, {79, 109, -29}, {110, 110, 36}, {111, 122, 7}, },
            {{65, 122, -31}, },
            {{65, 65, 3}, {66, 66, 37}, {67, 90, 3}, {97, 97, 7}, {98, 98, 38}, {99, 122, 7}, },
            {{65, 122, -33}, },
            {{65, 70, 3}, {71, 71, 39}, {72, 90, 3}, {97, 102, 7}, {103, 103, 40}, {104, 122, 7}, },
            {{65, 122, -35}, },
            {{65, 83, 3}, {84, 84, 41}, {85, 115, -8}, {116, 116, 42}, {117, 122, 7}, },
            {{65, 122, -37}, },
            {{65, 75, 3}, {76, 76, 43}, {77, 90, 3}, {97, 107, 7}, {108, 108, 44}, {109, 122, 7}, },
            {{65, 122, -39}, },
            {{65, 122, -5}, },
            {{65, 122, -5}, },
            {{65, 122, -5}, },
            {{65, 122, -5}, },
            {{65, 68, 3}, {69, 69, 45}, {70, 100, -15}, {101, 101, 46}, {102, 122, 7}, },
            {{65, 122, -45}, },
            {{65, 122, -5}, },
            {{65, 122, -5}, },
        }
        { // INENTRY
            {{9, 9, 1}, {10, 10, 2}, {12, 12, 3}, {13, 13, 4}, {32, 32, 5}, {40, 40, 6}, {41, 41, 7}, {44, 44, 8}, {61, 61, 9}, {65, 90, 10}, {97, 122, 11}, {123, 123, 12}, {125, 125, 13}, },
            {{9, 32, -2}, },
            {{9, 32, -2}, },
            {{9, 32, -2}, },
            {{9, 9, 1}, {10, 10, 14}, {12, 32, -2}, },
            {{9, 32, -2}, },
            {},
            {},
            {},
            {},
            {{43, 43, 15}, {45, 45, 16}, {46, 46, 17}, {47, 47, 18}, {48, 57, 19}, {58, 58, 20}, {65, 90, 21}, {97, 122, 22}, },
            {{43, 122, -12}, },
            {},
            {},
            {{9, 32, -2}, },
            {{43, 122, -12}, },
            {{43, 122, -12}, },
            {{43, 122, -12}, },
            {{43, 122, -12}, },
            {{43, 122, -12}, },
            {{43, 122, -12}, },
            {{43, 122, -12}, },
            {{43, 122, -12}, },
        }
        { // ASSIGN
            {{9, 9, 1}, {10, 10, 2}, {12, 12, 3}, {13, 13, 4}, {32, 32, 5}, {34, 34, 6}, {35, 35, 7}, {41, 41, 8}, {44, 44, 9}, {48, 57, 10}, {65, 90, 11}, {97, 122, 12}, {123, 123, 13}, {125, 125, 14}, },
            {{9, 32, -2}, },
            {{9, 32, -2}, },
            {{9, 32, -2}, },
            {{9, 9, 1}, {10, 10, 15}, {12, 32, -2}, },
            {{9, 32, -2}, },
            {},
            {},
            {},
            {},
            {{48, 57, 10}, },
            {{43, 43, 16}, {45, 45, 17}, {46, 46, 18}, {47, 47, 19}, {48, 57, 20}, {58, 58, 21}, {65, 90, 22}, {97, 122, 23}, },
            {{43, 122, -13}, },
            {},
            {},
            {{9, 32, -2}, },
            {{43, 122, -13}, },
            {{43, 122, -13}, },
            {{43, 122, -13}, },
            {{43, 122, -13}, },
            {{43, 122, -13}, },
            {{43, 122, -13}, },
            {{43, 122, -13}, },
            {{43, 122, -13}, },
        }
        { // BRACESTRING
            {{0, 8, 1}, {9, 9, 2}, {10, 10, 3}, {11, 11, 1}, {12, 12, 4}, {13, 13, 5}, {14, 31, 1}, {32, 32, 6}, {33, 122, 1}, {123, 123, 7}, {124, 124, 1}, {125, 125, 8}, {126, 65535, 1}, },
            {{0, 8, 1}, {11, 11, 1}, {14, 31, 1}, {33, 122, 1}, {124, 124, 1}, {126, 65535, 1}, },
            {{9, 10, -2}, {12, 13, -2}, {32, 32, 6}, },
            {{9, 32, -4}, },
            {{9, 32, -4}, },
            {{9, 9, 2}, {10, 10, 9}, {12, 32, -4}, },
            {{9, 32, -4}, },
            {},
            {},
            {{9, 32, -4}, },
        }
        { // QSTRING
            {{0, 33, 1}, {34, 34, 2}, {35, 91, 1}, {92, 92, 3}, {93, 65535, 1}, },
            {{0, 33, 1}, {35, 65535, -2}, },
            {},
            {{0, 33, 1}, {34, 34, 4}, {35, 65535, -2}, },
            {{0, 65535, -3}, },
        }
        { // REMOVE
            {{0, 8, 1}, {9, 9, 2}, {10, 10, 3}, {11, 11, 1}, {12, 12, 4}, {13, 13, 5}, {14, 31, 1}, {32, 32, 6}, {33, 122, 1}, {123, 123, 7}, {124, 124, 1}, {125, 125, 8}, {126, 65535, 1}, },
            {{0, 8, 1}, {11, 11, 1}, {14, 31, 1}, {33, 122, 1}, {124, 124, 1}, {126, 65535, 1}, },
            {{9, 10, -2}, {12, 13, -2}, {32, 32, 6}, },
            {{9, 32, -4}, },
            {{9, 32, -4}, },
            {{9, 9, 2}, {10, 10, 9}, {12, 32, -4}, },
            {{9, 32, -4}, },
            {},
            {},
            {{9, 32, -4}, },
        }
    };*/

    private static int[][] accept;
/*  {
        // NORMAL
        {5, 5, -1, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 1, 1, 2, 2, 4, 4, 3, 3, },
        // INENTRY
        {-1, 0, 0, 0, 0, 0, 9, 10, 11, 12, 15, 15, 6, 7, 0, 15, 15, 15, 15, 15, 15, 15, 15, },
        // ASSIGN
        {-1, 0, 0, 0, 0, 0, 16, 13, 10, 11, 14, 15, 15, 6, 7, 0, 15, 15, 15, 15, 15, 15, 15, 15, },
        // BRACESTRING
        {-1, 8, 0, 0, 0, 0, 0, 6, 7, 0, },
        // QSTRING
        {17, 17, 16, 17, 17, },
        // REMOVE
        {-1, 8, 0, 0, 0, 0, 0, 6, 7, 0, },

    };*/

    public static class State
    {
        public final static State NORMAL = new State(0);
        public final static State INENTRY = new State(1);
        public final static State ASSIGN = new State(2);
        public final static State BRACESTRING = new State(3);
        public final static State QSTRING = new State(4);
        public final static State REMOVE = new State(5);

        private int id;

        private State(int id)
        {
            this.id = id;
        }

        public int id()
        {
            return id;
        }
    }
}
